/*
 * Bullet.java
 *
 * Created on 19. februar 2004, 18:36
 */


package Game;

import java.awt.Color;
import java.awt.geom.Ellipse2D;


/** The Holy Hand Grenade of Antioch */
final class Bomb extends DefaultObject {
    
    
    private int timer = 120; // Ticks down. 0 == KABOOM;
    private double size = 150; // The size of the explosion
    private float alpha = 1; // Color of the explosion
    double startFirePower = 1.5;
    
    
    /** Creates a new instance of Bomb */
    Bomb(double x, double y, double angle, Color color, DefaultObject spawnedBy) {
        super(x, y, 0, 30, 30, color);
        this.spawnedBy = spawnedBy;
        onTeam = spawnedBy.onTeam;
        firePower = startFirePower;
        health = 10;
        ignore();
    }
    
    
    protected final void looseHealth(double firePower) {
        health += - firePower;
        if (health <= 0) {
            timer = 0; // Detonate if hit by a bullet or another explosion
        }
    }
    
    
    protected final void draw(java.awt.Graphics2D g2d) {
        Ellipse2D.Double circle = new Ellipse2D.Double();
        circle.setFrame(x - width / 2, y - height / 2, getWidth(), getHeight());
        g2d.setColor(new Color(1.0f, 0f, 0f, alpha));
        g2d.fill(circle);
    }
    
    
    protected void step() {
        if (isGhost()) {
            alpha += -0.03;
            if (alpha < 0) alpha = 0;
            
            firePower = alpha / startFirePower;
            if (firePower < 0) firePower = 0;
            if (alpha <= 0) Game.kill(this);
            moveTo(x, y);
        } else {
            if (timer > 0) {
                timer += -1;
            } else {
                rememberSpawnedBy = spawnedBy;
                spawnedBy = null;
                height += 10;
                width += 10;
                if (height > size) {
                    isGhost = true;
                }
                moveTo(x, y);
            }
        }
    }
}
