/*
 * Stupid.java
 *
 * Created on 19. februar 2004, 18:37
 */

package Game;

import java.awt.geom.Rectangle2D;
import java.awt.geom.AffineTransform;
import java.awt.Color;


/** This is an obstacle in the game, such as a wall */
final class Obstacle extends DefaultObject {
    
    /** Creates a new instance of Obstacle */
    Obstacle() {
        super(10,10,0,10,10, Color.DARK_GRAY);
        ignore();
    }
    
    
    /** Creates a new instance of Obstacle */
    Obstacle(double x, double y, double width, double height) {
        super(x, y, 0, width, height, Color.BLACK);
        ignore();
    }
    
      
    protected void draw(java.awt.Graphics2D g2d) {
        Rectangle2D.Double rectangle = new Rectangle2D.Double();
        rectangle.setFrame(0, 0, getWidth(), getHeight());
        AffineTransform at = AffineTransform.getTranslateInstance(x, y);
        at.rotate(Math.toRadians(angle));
        at.translate(-width / 2, -height / 2);
        g2d.setColor(getColor());
        g2d.fill(at.createTransformedShape(rectangle));
    }
    
    
    public String toString() {
        return "Obstacle";
    }
    
}
